#!usr/bin/php
<?php

	/*
_____________
B B C O D E PHP-Function

Version 1.0

_____________
L I C E N S E

Copyright (c) 2010, Alexander Sasse <alexander.sasse@xelaton.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

_________
U S A G E

convert([Text-String] $string);

*/

/**/
$fp = fopen("php://stdin", "r");
while($line = fgets($fp, 1024))
{
	$input .= $line;
}
fclose($fp);

echo convert($input);

?>
<style type="text/css">
.column
{
	-moz-column-count: 3;
	-moz-column-gap: 1em;
	-moz-column-rule: 1px solid black;
	-webkit-column-count: 3;
	-webkit-column-gap: 1em;
	-webkit-column-rule: 1px solid black;
	text-align: justify;
/*	font-family: "Arial Black"; */
}
</style>

<?php
/*
	Deprecated HTML-Tags in HTML-Specification HTML5, so don't use
	<acronym>, <applet>, <basefont>, <big>, <center>, <dir>, <font>, <frame>, 
	<frameset>, <isindex>, <s>, <strike>, <tt>, <u>, <xmp>	
	
	ToDo
	<br /> entfernen aus stellen, wo diese nicht reinsollen
	Listen
	PHP Code
*/

/*
	Taken from PHP-Documentation 
	Comments on highlight_string by fsx dot nr01 at gmail dot com
*/
function printCode($source_code)
    {

        if (is_array($source_code))
            return false;
       
        $source_code = explode("\n", str_replace(array("\r\n", "\r"), "\n", trim($source_code)));
        $line_count = 1;

        foreach ($source_code as $code_line)
        {
            $formatted_code .= '<tr><td>'.$line_count.'</td>';
            $line_count++;
           // highlight_string($var, true) --> durch das true wird es nicht sofort ausgegeben
            if (ereg('<\?(php)?[^[:graph:]]', $code_line))
                $formatted_code .= '<td>'. str_replace(array('<code>', '</code>'), '', highlight_string($code_line, true)).'</td></tr>';
            else
                $formatted_code .= '<td>'.ereg_replace('(&lt;\?php&nbsp;)+', '', str_replace(array('<code>', '</code>'), '', highlight_string('<?php '.$code_line, true))).'</td></tr>';
        }

        return '<table style="font: 1em Consolas, \'andale mono\', \'monotype.com\', \'lucida console\', monospace;">'.$formatted_code.'</table>';
    }
    

function convert($input)
{

	$linkurl_thread = 'showthread.php?t=';
	$linkurl_post = 'showthread.php?p=';

	$search = array('[b]', 
					'[/b]',
					'[i]', 
					'[/i]',
					'[u]', 
					'[/u]',
					'[s]',
					'[/s]',
					'[*]',
					'[ul]',
					'[/ul]',
					'[ol]',
					'[/ol]',
					'[li]',
					'[/li]',
					'[code]',
					'[/code]',
					'[quote]',
					'[/quote]',
					'[highlight]',
					'[/highlight]',
					'[sup]',
					'[/sup]',
					'[sub]',
					'[/sub]',
					'[h1]',
					'[/h1]',
					'[h2]',
					'[/h2]',
					'[h3]',
					'[/h3]',
					'[h4]',
					'[/h4]',
					'[h5]',
					'[/h5]',
					'[h6]',
					'[/h6]',
	);
	$replace = array('<strong>',
					 '</strong>',
					 '<em>',
					 '</em>',
					 '<span style="text-decoration:underline;">',
					 '</span>',
					 '<span style="text-decoration:line-through;">',
					 '</span>',
					 '<li>',
					 '<ul>',
					 '</ul>',
					 '<ol>',
					 '</ol>',
					 '<li>',
					 '</li>',
					 '<pre>',
					 '</pre>',
					 '<blockquote>',
					 '</blockquote>',
					 '<strong><span style="color:red">',
					 '</span></strong>',
					 '<sup>',
					 '</sup',
					 '<sub>',
					 '</sub>',
					 '<h1>',
					 '</h1>',
					 '<h2>',
					 '</h2>',
					 '<h3>',
					 '</h3>',
					 '<h4>',
					 '</h4>',
					 '<h5>',
					 '</h5>',
					 '<h6>',
					 '</h6>',
	);
	
	$preg_search = array('/\[url\](.*?)\[\/url\]/is',
							'/\[url\=(.*?)\](.*?)\[\/url\]/is',
							'/\[mail\](.*?)\[\/mail\]/is',
							'/\[mail\=(.*?)\](.*?)\[\/mail\]/is',						
							'/\[align\=(left|center|right|justify)\](.*?)\[\/align\]/is',
							'/\[center\](.*?)\[\/center\]/is', // diese knnte man auch in den einfachen Teil reinstecken
							'/\[left\](.*?)\[\/left\]/is',
							'/\[right\](.*?)\[\/right\]/is',
							'/\[justify\](.*?)\[\/justify\]/is',
							'/\[column\](.*?)\[\/column\]/is',
							
							'/\[img\](.*?)\[\/img\]/is',
							'/\[img\=([0-9]{1,})x([0-9]{1,})\](.*?)\[\/img\]/is',
							'/\[email\=(.*?)\](.*?)\[\/email\]/is',                     
							'/\[email\](.*?)\[\/email\]/is',              
							
							'/\[thread\](.*?)\[\/thread\]/is',
							'/\[thread\=(.*?)\](.*?)\[\/thread\]/is',
							'/\[post\](.*?)\[\/post\]/is',
							'/\[post\=(.*?)\](.*?)\[\/post\]/is', 
							               
							'/\[font\=(.*?)\](.*?)\[\/font\]/is',                     
							'/\[size\=(.*?)\](.*?)\[\/size\]/is',                     
							'/\[color\=(.*?)\](.*?)\[\/color\]/is',
							
							'/\[list\=1\]/is',
							'/\[list\=a\]/s', // muss das s am Ende sein? //- mark ToDo
							'/\[list\=A\]/s',
							'/\[list\=i\]/s',
							'/\[list\=I\]/s',
							'/\[list\=(circle|disc|square)\]/s',
							
							'/\[\/list\]/is',
							
							'/\[quote\=(.*?);(.*?)\]/', //- mark ToDo eventuell ein i setzen
							'/\[quote\=(.*?)\]/',
							);
	$preg_replace = array('<a href="$1" target="_blank">$1</a>',
							'<a href="$1" target="_blank">$2</a>',
							'<a href=mailto:"$1">$1</a>',
							'<a href="mailto:$1">$2</a>',
							'<div style="text-align: $1;">$2</div>', 
							'<div style="text-align: center;">$1</div>',
							'<div style="text-align: left;">$1</div>',
							'<div style="text-align: right;">$1</div>',
							'<div style="text-align: justify;">$1</div>',
							'<div class="column">$1</div>',
							
							'<img src="$1" />',
							'<img width="$1" height="$2" src="$3" />',
							'<a href="mailto:$1">$2</a>', 
							'<a href="mailto:$1">$1</a>', 
							
							'<a href="'.$linkurl_thread.'$1">$1</a>',
							'<a href="'.$linkurl_thread.'$1">$2</a>',
							'<a href="'.$linkurl_post.'$1">$1</a>',
							'<a href="'.$linkurl_post.'$1">$2</a>',
							
							'<span style="font-family: $1;">$2</span>', 
							'<span style="font-size: $1;">$2</span>', 
							'<span style="color: $1;">$2</span>',
							
							'<ol style="list-style-type:decimal">',
							'<ol style="list-style-type:lower-alpha">',
							'<ol style="list-style-type:upper-alpha">',
							'<ol style="list-style-type:lower-roman">',
							'<ol style="list-style-type:upper-roman">',
							'<ol style="list-style-type:$1">',
							
							'</ol>',
							
							'<blockquote><strong>$1</strong> <a href="'.$linkurl_post.'$2">&gt;</a><br />',
							'<blockquote><strong>$1</strong><br />',
							
//							'<pr>$1</pre>',
	);
	
	$preg_search_social_links = array(
									  '/\[youtube\](.*?)\[\/youtube\]/is',
									  '/\[wiki\](.*?)\[\/wiki\]/is',
									  '/\[twitter\](.*?)\[\/twitter\]/is',
									  '/\[flickr\](.*?)\[\/flickr\]/is',
	);
	
	$social_media_links =  array(
	'Youtube' => array('Link' => 'http://www.youtube.com/watch?v=$1',
					  'Description' => 'YouTube $1'),
	'Twitter' => array('Link' => 'http://twitter.com/$1',
				'Description' => 'Follow $1 on Twitter'),
	'Wikipedia' => array('Link' => 'http://de.wikipedia.org/wiki/$1',
				'Description' => 'Read more about $1 on Wikipedia'),
	'Flickr' => array('Link' => 'http://flickr.com/photos/$1',
				'Description' => 'Visit $1 Flickr-Account'),
	);
	
	$preg_replace_social_links = array(
										'<a href="'.$social_media_links['Youtube']['Link'].'">'.$social_media_links['Youtube']['Description'].'</a>',
										'<a href="'.$social_media_links['Wikipedia']['Link'].'">'.$social_media_links['Wikipedia']['Description'].'</a>',
										'<a href="'.$social_media_links['Twitter']['Link'].'">'.$social_media_links['Twitter']['Description'].'</a>',
										'<a href="'.$social_media_links['Flickr']['Link'].'">'.$social_media_links['Flickr']['Description'].'</a>',
	);
// saving certain Elements of htmlentities
	preg_match_all('/\[html\](.*?)\[\/html\]/is', $input, $results_html);
	preg_match_all('/\[php\](.*?)\[\/php\]/is', $input, $results_php);	
	$input = htmlentities($input, ENT_NOQUOTES, "UTF-8");

// saving noparse elements
	preg_match_all('/\[noparse\](.*?)\[\/noparse\]/is', $input, $results_noparse);

	$result =  str_replace($search, $replace, $input); // simple replacements
	$result = preg_replace($preg_search, $preg_replace, $result); // complex replacements
	
	$result = preg_replace($preg_search_social_links, $preg_replace_social_links, $result);
	
// transformation of html-elements which shall be shown
	if(is_array($results_html))
	{
		foreach($results_html[1] as $string_to_replace)
		{
			$result = preg_replace('/\[html\](.*?)\[\/html\]/is', $string_to_replace, $result, 1);
		}
	}

// rewriting noparse elements
	if(is_array($results_noparse))
	{
		foreach($results_noparse[1] as $string_to_replace)
		{
			$result = preg_replace('/\[noparse\](.*?)\[\/noparse\]/is', $string_to_replace, $result, 1);
		}
	}
	
	// saving php-elements
	$zwischenresultat = explode("\n", $result);
	for($i = 0; $i < count($zwischenresultat); $i++)
	{
					if(strpos($zwischenresultat[$i], "<ol") === false && strpos($zwischenresultat[$i], "<li>") === false && strpos($zwischenresultat[$i], "</ol>") === false )
		{
			$zwischenresultat[$i] .= "<br />";
		}
	}
	$result = implode("\n", $zwischenresultat);

	$result = str_replace('</li><br />', '</li>', $result);
	// special output for php elements	
	
	if(is_array($results_php))
	{
		foreach($results_php[1] as $string_to_replace)
		{
			//highlight_string($string_to_replace);
			$result = preg_replace('/\[php\](.*?)\[\/php\]/is', printCode($string_to_replace), $result, 1);
		}
	}
	return $result;
}

?>